/* -------------------------------------------------------------------------------
gd_font	- version 0.1 (Jan. 10. 1998)

Copyright (c) by Collin R. Mulliner <collin@mulliner.org>

This is the font builder for gDraw 1.1

WebSite: http://www.mulliner.org/palm/
------------------------------------------------------------------------------- */
#include <stdio.h>
#include "help.h"

struct font_type {
	char w;
	char the_char;
	char data[30];
	int data_size;
	struct font_type *next;
};	

char db_name[33];

struct font_type *fnt_ptr_a;
struct font_type *fnt_ptr_c;

int alpha;
int high;
char font_name[21];

int main(int argc, char *argv[])
{
	FILE *fp;
	int i;
	
	if (argc < 2) { printf(HELP); return; }		// no args, print help and exit

	for (i = 0; i < 32; i++) { font_name[i] = '\0'; }
	for (i = 0; i < 32; i++) { db_name[i] = '\0'; }

	printf("Number of characters in %s ? : ",argv[1]);
	scanf("%d",&alpha);
	printf("Character hight (in pixels) : ");
	scanf("%d",&high);
	printf("Font name (32 chars max) : ");
	scanf("%s",font_name);

	strcpy(db_name, font_name);

	build_fnt_in_mem(argv[1]);

	fp = fopen(argv[2], "w");

	write_pdb_header(fp);
	write_rec_headers(fp, alpha);
	write_font_id(fp);
	write_data(fp, alpha);

	fclose(fp);
}

/* -------------------------------------------------------------
The pdb Header without the Record headers is 78 Bytes in size
------------------------------------------------------------- */
write_pdb_header(FILE *fp) 
{
	int i;

	for (i = 0; i < 32; i++) {
		fputc(db_name[i], fp);
	}

	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the flags
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the version 
	fputc(0x06, fp);
	fputc(0xD1, fp);
	fputc(0x44, fp);
	fputc(0xAE, fp);
	//	the creation time 
	fputc(0x06, fp);
	fputc(0xD1, fp);
	fputc(0x44, fp);
	fputc(0xAE, fp);
	//	the modifi time 
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the backup time 
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the modifi number 
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the app info offset 
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the sort info offset 

	fputc('F', fp);
	fputc('O', fp);
	fputc('N', fp);
	fputc('T', fp);
	//	the DB Type "FONT" 
	fputc('C', fp);
	fputc('R', fp);
	fputc('M', fp);
	fputc('3', fp);
	//	the CRID 

	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the unique ID seed 
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	fputc(0x00, fp);
	//	the next record list ID

	fputc(0x00, fp);
	fputc((alpha + 1), fp);
 	// num records	
}

write_font_id(FILE *fp)
{
	int i;

	fputc(high, fp);
	// the char high
	for (i = 0; i < 21; i++) { fputc(font_name[i], fp); }
}

build_fnt_in_mem(char f_name[])
{
	FILE *fp;
	int i, cc, l, pix, fc, modval;
	char c;
	char achar[300];

	fp = fopen(f_name, "r");

	fnt_ptr_a = (struct font_type *) malloc(sizeof(struct font_type));
	fnt_ptr_c = fnt_ptr_a;

	fc = 0;
	while (fc < alpha) {
		fscanf(fp, "%d", &fnt_ptr_c->w);
		c = fgetc(fp);		// read the 0x0a (CR)
		c = fgetc(fp);
		fnt_ptr_c->the_char = c;
	
		i = 0;
		while (i < (fnt_ptr_c->w * high)) {
			c = fgetc(fp);
			if (c == '1' || c == '0') {
				achar[i] = c;
				i++;
			}
		}

		cc = 128;
		pix = 0;
		l = 0;
		modval = (fnt_ptr_c->w * high) % 8;
		for (i = 0; i < modval; i++) {
			achar[fnt_ptr_c->w*high+i] = '0';
		}

		for (i = 0; i < (fnt_ptr_c->w * high)-1+modval; i++) {
			if (achar[i] == '1') {
				pix = pix + cc;
				if (cc > 1) cc = cc / 2;
				else cc = 0;
			}
			else if (achar[i] == '0') {
				if (cc > 1) cc = cc / 2;
				else cc = 0;
			}
			else {
				if (cc > 1) cc = cc / 2;
				else cc = 0;
			}
			if (cc == 0) {
				fnt_ptr_c->data[l] = pix;
				cc = 128;
				pix = 0;
				l++;
			}
		}
		l++;
		fnt_ptr_c->data_size = l;
		printf("l: %d\n",l);

		// for DEBUGING ONLY
		printf("Length (in pixles): %d\n",fnt_ptr_c->w);
		printf("Char: %c\n",fnt_ptr_c->the_char);
		printf("\n");
		for (i = 0; i < l; i++) {
			printf("\\x%x", fnt_ptr_c->data[i]);
		}
		printf("\n");
		// for DEBUGING ONLY

		fnt_ptr_c->next = (struct font_type *) malloc(sizeof(struct font_type));
	 	fnt_ptr_c = fnt_ptr_c->next;
		fc++;			
		c = fgetc(fp); 
	}
	fclose(fp);
} 

write_rec_headers(FILE *fp, int count_recs)
{
	int new_offset, adding_offset, *nop;
	int i, i2;
	unsigned char offset_out[4];
	char rec_number;

	count_recs++;

	rec_number = 0;
	new_offset = 78 + (count_recs * 8);
	make_offset(new_offset, offset_out);

	for (i = 0; i < 4; i++) {
		fputc(offset_out[i], fp);
	}

	fputc(0x40, fp);
	fputc(0x6F, fp);
	fputc(0x80, fp);
	fputc(rec_number, fp);
	// record attributes	

	rec_number++;

	new_offset = 78 + (count_recs * 8) + 22;
	make_offset(new_offset, offset_out);

	for (i = 0; i < 4; i++) {
		fputc(offset_out[i], fp);
	}

	fputc(0x40, fp);
	fputc(0x6F, fp);
	fputc(0x80, fp);
	fputc(rec_number, fp);

	fnt_ptr_c = fnt_ptr_a;
	adding_offset = 22;
	for (i = 1; i < (count_recs-1); i++) {
	 	adding_offset = adding_offset + fnt_ptr_c->data_size + 2;	
		new_offset = 78 + (count_recs * 8);
		new_offset = new_offset + adding_offset;
		make_offset(new_offset, offset_out);
		for (i2 = 0; i2 < 4; i2++) {
			fputc(offset_out[i2], fp);
		}
		rec_number++;
		fputc(0x40, fp);
		fputc(0x6F, fp);
		fputc(0x80, fp);
		fputc(rec_number, fp);
		// record attributes
		fnt_ptr_c = fnt_ptr_c->next;	
	}
	count_recs--;
}

make_offset(int to, char oo[])
{
	int z3, zcc, i;

	for (i = 0; i < 3; i++) { oo[i] = '\x00'; }
	
	if (to < 256) {
		oo[3] = to;
	}
	else if (to > 255 && to < 65535) {
		z3 = to;
		zcc = z3 / 256;
		oo[3] = to - (256 * zcc);
		oo[2] = zcc;
	}
}

write_data(FILE *fp, int count_recs)
{
	int i, i2;

	fnt_ptr_c = fnt_ptr_a;

	for (i = 0; i < count_recs; i++) {
		fputc(fnt_ptr_c->w, fp);
		fputc(fnt_ptr_c->the_char, fp);
		for (i2 = 0; i2 < fnt_ptr_c->data_size; i2++) {
			fputc(fnt_ptr_c->data[i2], fp);
		}
		fnt_ptr_c = fnt_ptr_c->next;
	}
}
